<script setup lang="ts">
  import { getTranslatedProperty } from '@shopware-pwa/helpers-next';
  const props = defineProps<{
    data: {
      productId: string;
      parentId?: string;
    };
    controller: ReturnType<typeof useModal>;
  }>();

  const isNetPrice = ref(false);
  const isLoading = ref();

  const handleDisplayPrice = () => {
    isNetPrice.value = !isNetPrice.value;
  };

  const EMPTY_VALUE = '-';
  const { getAdminProduct, prices, deliverability, specifications } = useAdminProduct();

  const { getFormattedPrice } = usePrice();
  const handleDisplayBoolean = (value: boolean | null | undefined) => {
    return `${value ? 'Yes' : 'No'}`;
  };

  const displayPrice = (price: number) => {
    return getFormattedPrice(price) || EMPTY_VALUE;
  };

  onBeforeMount(async () => {
    isLoading.value = true;
    await getAdminProduct(props.data);
    isLoading.value = false;
  });
</script>

<template>
  <SwModal :controller="controller" panel-class="md:min-w-[45rem]">
    <template #header>
      <div
        class="border-(border b-1) bg-background-raised z-50 flex items-center justify-between rounded-t-none px-6 py-4 md:rounded-t-md"
      >
        <div class="flex flex-col">
          <h3 class="text-lg/[1.625rem] font-bold capitalize tracking-[0.01125rem]">
            {{ getTranslatedProperty(product, 'name') }}
          </h3>
          <span class="text-(information-subdued xs) font-medium">
            {{ $t('product.details') }}
          </span>
        </div>

        <button
          type="button"
          class="text-information hover:bg-interactive-hover active:bg-interactive-pressed rounded-md bg-transparent p-2 outline-none"
          @click="controller.close"
        >
          <span class="sr-only">{{ $t('close') }}</span>
          <span class="i-sw-regular:times-xs" />
        </button>
      </div>
    </template>
    <template #body>
      <div class="flex flex-col space-y-6">
        <!-- Price -->
        <div>
          <div class="flex flex-col space-y-4">
            <div class="flex justify-between">
              <span class="font-bold">{{ $t('product.prices') }}</span>
              <div class="flex">
                <SwButton
                  :variant="isNetPrice ? 'primary' : 'action'"
                  class="rounded-r-none"
                  size="small"
                  @click="handleDisplayPrice"
                >
                  {{ $t('product.price.net') }}
                </SwButton>
                <SwButton
                  :variant="isNetPrice ? 'action' : 'primary'"
                  class="rounded-l-none"
                  size="small"
                  @click="handleDisplayPrice"
                >
                  {{ $t('product.price.gross') }}
                </SwButton>
              </div>
            </div>
            <div class="flex gap-x-4 md:gap-x-8">
              <div class="flex-1">
                <p class="text-(xs information-subdued) font-medium">
                  {{ $t('product.price.taxRate') }}
                </p>
                <span v-skeleton="isLoading" class="text-sm/6 font-semibold">
                  {{ `${prices?.taxRate}%` || EMPTY_VALUE }}
                </span>
              </div>
              <div class="flex-1">
                <p class="text-(xs information-subdued) font-medium">
                  {{ $t('product.price.label') }}
                </p>
                <span v-skeleton="isLoading" class="text-sm/6 font-semibold">
                  {{
                    isNetPrice ? displayPrice(prices?.price.net) : displayPrice(prices?.price.gross)
                  }}
                </span>
              </div>
              <div class="flex-1">
                <p class="text-(xs information-subdued) font-medium">
                  {{ $t('product.price.purchasePrice') }}
                </p>
                <span v-skeleton="isLoading" class="text-sm/6 font-semibold">
                  {{
                    isNetPrice
                      ? displayPrice(prices?.purchasePrice.net)
                      : displayPrice(prices?.purchasePrice.gross)
                  }}
                </span>
              </div>
            </div>
            <div class="flex gap-x-4 md:gap-x-8">
              <div class="flex-1">
                <p class="text-(xs information-subdued) font-medium">
                  {{ $t('product.price.listPrice') }}
                </p>
                <span v-skeleton="isLoading" class="text-sm/6 font-semibold">
                  {{
                    isNetPrice
                      ? displayPrice(prices?.listPrice.net)
                      : displayPrice(prices?.listPrice.gross)
                  }}
                </span>
              </div>
              <div class="flex-1">
                <p class="text-(xs information-subdued) font-medium">
                  {{ $t('product.price.cheapestPriceLast30Days') }}
                </p>
                <span v-skeleton="isLoading" class="text-sm/6 font-semibold">
                  {{
                    isNetPrice
                      ? displayPrice(prices?.cheapestPrice.net)
                      : displayPrice(prices?.cheapestPrice.gross)
                  }}
                </span>
              </div>
              <div class="flex-1" />
            </div>
          </div>
        </div>
        <div class="border-(border b)" />
        <!-- Deliverability -->
        <div>
          <div class="flex flex-col space-y-4">
            <span class="font-bold">{{ $t('product.deliverability.label') }}</span>

            <div class="flex gap-x-4 md:gap-x-8">
              <div class="flex-1">
                <p class="text-(xs information-subdued) font-medium">
                  {{ $t('product.deliverability.stock') }}
                </p>
                <span v-skeleton="isLoading" class="text-sm/6 font-semibold">{{
                  deliverability?.stock || EMPTY_VALUE
                }}</span>
              </div>
              <div class="flex-1">
                <p class="text-(xs information-subdued) font-medium">
                  {{ $t('product.deliverability.availableStock') }}
                </p>
                <span v-skeleton="isLoading" class="text-sm/6 font-semibold">
                  {{ deliverability?.availableStock || EMPTY_VALUE }}
                </span>
              </div>
              <div class="flex-1">
                <p class="text-(xs information-subdued) font-medium">
                  {{ $t('product.deliverability.isOnClearanceSale') }}
                </p>
                <span v-skeleton="isLoading" class="text-sm/6 font-semibold">
                  {{ handleDisplayBoolean(deliverability?.isCloseout) }}
                </span>
              </div>
            </div>
            <div class="flex gap-x-4 md:gap-x-8">
              <div class="flex-1">
                <p class="text-(xs information-subdued) font-medium">
                  {{ $t('product.deliverability.deliveryTime') }}
                </p>
                <span v-skeleton="isLoading" class="text-sm/6 font-semibold">
                  {{ getTranslatedProperty(deliverability?.deliveryTime, 'name') || EMPTY_VALUE }}
                </span>
              </div>
              <div class="flex-1">
                <p class="text-(xs information-subdued) font-medium">
                  {{ $t('product.deliverability.restockTime') }}
                </p>
                <span v-skeleton="isLoading" class="text-sm/6 font-semibold">
                  {{
                    deliverability?.restockTime
                      ? `${deliverability.restockTime} ${$t('product.deliverability.days')}`
                      : EMPTY_VALUE
                  }}
                </span>
              </div>
              <div class="flex-1">
                <p class="text-(xs information-subdued) font-medium">
                  {{ $t('product.deliverability.freeShipping') }}
                </p>
                <span v-skeleton="isLoading" class="text-sm/6 font-semibold">
                  {{ handleDisplayBoolean(deliverability?.shippingFree) }}
                </span>
              </div>
            </div>
            <div class="flex gap-x-4 md:gap-x-8">
              <div class="flex-1">
                <p class="text-(xs information-subdued) font-medium">
                  {{ $t('product.deliverability.minOrderQuantity') }}
                </p>
                <span v-skeleton="isLoading" class="text-sm/6 font-semibold">{{
                  deliverability?.minPurchase || EMPTY_VALUE
                }}</span>
              </div>
              <div class="flex-1">
                <p class="text-(xs information-subdued) font-medium">
                  {{ $t('product.deliverability.purchaseSteps') }}
                </p>
                <span v-skeleton="isLoading" class="text-sm/6 font-semibold">{{
                  deliverability?.purchaseSteps || EMPTY_VALUE
                }}</span>
              </div>
              <div class="flex-1">
                <p class="text-(xs information-subdued) font-medium">
                  {{ $t('product.deliverability.maxOrderQuantity') }}
                </p>
                <span v-skeleton="isLoading" class="text-sm/6 font-semibold">
                  {{ deliverability?.maxPurchase || EMPTY_VALUE }}
                </span>
              </div>
            </div>
          </div>
        </div>
        <div class="border-(border b)" />
        <!-- Specifications -->
        <div>
          <div class="flex flex-col space-y-4">
            <span class="font-bold">{{ $t('product.specifications.label') }}</span>

            <div class="flex gap-x-4 md:gap-x-8">
              <div class="flex-1">
                <p class="text-(xs information-subdued) font-medium">
                  {{ $t('product.specifications.width') }}
                </p>
                <span v-skeleton="isLoading" class="text-sm/6 font-semibold">
                  {{
                    specifications?.width
                      ? $t('product.specifications.sizeDetail', { p: specifications.width })
                      : EMPTY_VALUE
                  }}
                </span>
              </div>
              <div class="flex-1">
                <p class="text-(xs information-subdued) font-medium">
                  {{ $t('product.specifications.height') }}
                </p>
                <span v-skeleton="isLoading" class="text-sm/6 font-semibold">
                  {{
                    specifications?.height
                      ? $t('product.specifications.sizeDetail', { p: specifications.height })
                      : EMPTY_VALUE
                  }}
                </span>
              </div>
              <div class="flex-1">
                <p class="text-(xs information-subdued) font-medium">
                  {{ $t('product.specifications.length') }}
                </p>
                <span v-skeleton="isLoading" class="text-sm/6 font-semibold">
                  {{
                    specifications?.length
                      ? $t('product.specifications.sizeDetail', { p: specifications.length })
                      : EMPTY_VALUE
                  }}
                </span>
              </div>
            </div>
            <div class="flex gap-x-4 md:gap-x-8">
              <div class="flex-1">
                <p class="text-(xs information-subdued) font-medium">
                  {{ $t('product.specifications.weight') }}
                </p>
                <span v-skeleton="isLoading" class="text-sm/6 font-semibold">
                  {{
                    specifications?.weight
                      ? `${specifications.weight} ${getTranslatedProperty(
                          specifications.unit,
                          'shortCode',
                        )}`
                      : EMPTY_VALUE
                  }}
                </span>
              </div>
              <div class="flex-1">
                <p class="text-(xs information-subdued) font-medium">
                  {{ $t('product.specifications.sellingUnit') }}
                </p>
                <span v-skeleton="isLoading" class="text-sm/6 font-semibold">
                  {{
                    specifications?.purchaseUnit
                      ? `${specifications.purchaseUnit} ${getTranslatedProperty(
                          specifications.unit,
                          'shortCode',
                        )}`
                      : EMPTY_VALUE
                  }}
                </span>
              </div>
              <div class="flex-1">
                <p class="text-(xs information-subdued) font-medium">
                  {{ $t('product.specifications.scaleUnit') }}
                </p>
                <span v-skeleton="isLoading" class="text-sm/6 font-semibold">
                  {{ getTranslatedProperty(specifications?.unit, 'name') || EMPTY_VALUE }}
                </span>
              </div>
            </div>
            <div class="flex gap-x-4 md:gap-x-8">
              <div class="flex-1">
                <p class="text-(xs information-subdued) font-medium">
                  {{ $t('product.specifications.packagingUnit') }}
                </p>
                <span v-skeleton="isLoading" class="text-sm/6 font-semibold">
                  {{ getTranslatedProperty(specifications, 'packUnit') }}
                  {{
                    specifications?.packUnit && specifications.packUnitPlural ? '/' : EMPTY_VALUE
                  }}
                  {{ getTranslatedProperty(specifications, 'packUnitPlural') }}
                </span>
              </div>
              <div class="flex-1">
                <p class="text-(xs information-subdued) font-medium">
                  {{ $t('product.specifications.basicUnit') }}
                </p>
                <span v-skeleton="isLoading" class="text-sm/6 font-semibold">
                  {{ specifications?.referenceUnit || EMPTY_VALUE }}
                </span>
              </div>
              <div class="flex-1" />
            </div>
          </div>
        </div>
      </div>
    </template>
    <template #footer>
      <SwButton variant="action" @click="controller.close">{{ $t('close') }}</SwButton>
    </template>
  </SwModal>
</template>
